#### code description
---

1. 错误码由7位数字组成
2. 错误码左起两位固定为11，格式为：11XXXXX
3. 错误码左起第三位和四位用于表示进程模块的代号
4. 错误码最右侧三位表示特定进程模块内的错误代号
3. 公共错误码左侧四位固定为1199，格式位：1199XXX
4. API层错误码左侧四位固定为1100， 格式为：1100XXX
5. topo进程错误左侧四位固定为 1101，格式为：1101XXX
6. object进程错误码左侧四位固定为 1102，格式为：1102XXX
7. event 进程错误码左侧四位固定为 1103，格式为：1103XXX
8. host 进程错误码左侧四位固定位  1104|1110，格式为：1104XXX|1110xxx
9. hostcontroller 进程错误码左侧四位固定位  1106，格式为：1106XXX
10. proccontroller 进程错误码左侧四位固定位  1107，格式为：1107XXX
11. procserver 进程错误码左侧四位固定位  1108，格式为：1108XXX
12. auditlog 进程错误码左侧四位固定位  1109，格式为：1109XXX
13. web 进程错误码左侧四位固定位  1111，格式为：1111XXX
14. api server v2  接口错误码左侧四位固定位  1170，格式为：1170XXX


### common

```json
{
    "1199000": "反序列化JSON数据失败",
    "1199001": "序列化JSON失败",
    "1199002": "HTTP请求失败",
    "1199003": "输入参数无效",
    "1199004": "数据数据读取失败",
    "1199005": "输入内容为空",
    "1199006": "'%s' 数据参数校验不通过",
    "1199007": "'%s' 必须为字符串类型",
    "1199008": "'%s' 不可以被省略",
    "1199009": "'%s' 参数必须是整形",
    "1199010": "'%s' 未赋值",
    "1199011": "'%s' 参数无效或不存在",
    "1199012": "唯一性校验不通过",
    "1199013": "读取Data字段数据失败",
    "1199014": "数据重复",
    "1199015": "数据越界",
    "1199016": "字段正则校验失败",
    "1199017": "查询数据失败",
    "1199018": "新加数据失败",
    "1199019": "未找到相关数据",
    "1199020": "更新数据失败",
    "1199021": "删除数据失败",
    "1199022": "依赖服务[%s]未启动",
    "1199024": "'%s' 必须为字符串类型",
    "1199025": "'%s' 必须为布尔类型",
    "1199026": "配置文件缺少[%s]配置项",
    "1199027": "[%s]授权信息查询失败",
    "1199028": "字段值校验不通过",
    "1199029": "函数返回值格式有问题",
    "1199030": "HTTP POST解析失败",
    "1199031": "'%s' 初始化失败",

    "":""
}

```

### event_server

```json
{
    "1103000": "创建实例失败",
    "1103001": "删除实例失败",
    "1103002": "更新实例失败",
    "1103003": "查询实例数据失败",
    "1103004": "创建模型失败",
    "1103005": "删除模型失败",
    "1103006": "更新模型失败",
    "1103007": "查询模型失败"
}

```

### host_controller

```json
{
    "1106000":"查询主机实例失败",
    "1106002":"新增主机实例失败",
    "1106003":"查询主机快照失败",
    "1106004":"转移主机模块失败",
    "1106005":"删除主机默认集群模块失败",
    "1106006":"获取主机模块关系失败",
    "1106007":"删除原有主机模块关系失败",
    "1106008":"获取主机已经绑定关系模块失败",
    "1106009":"从资源池转移主机失败",
    "1106010":"主机已经属于其他业务，请刷新页面后，重新选择要分配的主机",
    "1106011":"主机属于空闲机以外的模块",
    "1106012":"转移主机到资源池失败",
    "1106013":"新加用户自定义配置",
    "1106014":"查询主机收藏失败",
    "1106015":"创建主机收藏失败",
    "1106016":"修改主机收藏失败",
    "1106017":"修改主机收藏失败",
    "":""
}
```

### host_server

```json
{
       "1110001": "查询主机失败",
	"1110002": "更新主机失败",
	"1110003": "更新主机字段失败",
	"1110004": "创建主机失败",
	"1110005": "修改主机失败",
	"1110006": "删除主机失败",
	"1110007": "主机字段校验失败",
	"1110008": "主机找不到",
	"1110009": "主机长度错误",
	"1110010": "获取主机详情失败",
	"1110011": "获取主机快照数据失败",
	"1110012": "主机字段校验失败",
	"1110013": "添加主机收藏失败",
	"1110014": "主机收藏名为空",
	"1110015": "更新主机收藏失败",
	"1110016": "删除主机收藏失败",
	"1110017": "获取主机收藏失败",
	"1110018": "创建主机查询历史失败",
	"1110019": "获取主机查询历史失败",
	"1110020": "保存字段配置失败",
	"1110021": "获取字段配置失败",
	"1110022": "获取默认字段配置失败",
	"1110023": "主机'%s'不属于当前业务",
	"1110024": "获取主机'%s'的业务失败",
	"1110025": "从资源池删除主机'%s'失败, error:%s",
	"1110026": "新加主机'%s'与模块关系失败, error:%s",
	"1110027": "主机'%s' 转移到资源池失败, error:%s",
	"1110028": "修改主机关系失败",

	"":""
}

```

### migrate

```json
{
    "15000":"迁移数据失败",
    "":""
}
```

### object_controller

```json
{
	"1102000": "属性分组存储失败",
	"1102001": "删除属性分组失败",
	"1102002": "查询属性分组失败",
	"1102003": "更新属性分组失败",
	"1102004": "新增实例失败",
	"1102005": "更新实例失败",
	"1102006": "删除实例失败",
	"1102007": "查询实例失败",
	"": ""
}

```

### proc_controller

```json
{
    "1107001": "从模块移除进程失败",
	"1107002": "新加进程到模块失败",
    "1107003": "查询进程失败",
    "":""
}

```

### proc_server

```json
{
    "1108001": "查询进程详情失败",
    "1108002": "绑定进程模型失败",
    "1108003": "解除进程模型绑定失败",
    "1108004": "解除进程模型绑定失败",
    "1108005": "更新进程失败",
    "1108006": "查询进程失败",
    "1108007": "删除进程失败",
    "1108008": "创建进程失败",
    "": ""
}
```

### topo_server

``` json
{
	"1101000": "创建实例失败",
	"1101001": "删除实例失败",
	"1101002": "更新实例失败",
	"1101003": "查询实例数据失败",
	"1101004": "创建模型失败",
	"1101005": "删除模型失败",
	"1101006": "更新模型失败",
	"1101007": "查询模型失败",
	"1101008": "创建集群失败",
	"1101009": "删除集群失败",
	"1101010": "更新集群信息失败",
	"1101011": "查询集群信息失败",
	"1101013": "创建模型失败",
	"1101014": "删除模型失败",
	"1101015": "更新模型失败",
	"1101016": "查询模型失败",
	"1101017": "创建模型实例失败",
	"1101018": "删除模型属性失败",
	"1101019": "更新模型属性失败",
	"1101020": "查询模型属性失败",
	"1101021": "创建模型分类失败",
	"1101022": "删除模型分类失败",
	"1101023": "更新模型分类失败",
	"1101024": "查询模型分类失败",
	"1101025": "创建模型属性分组失败",
	"1101026": "删除模型属性分组失败",
	"1101027": "更新模型属性分组失败",
	"1101028": "查询模型属性分组失败",
	"1101029": "分类下有模型，不允许删除",
	"1101030": "目标下拥有主机",
	"1001031": "删除业务失败",
	"1001032": "更新业务失败",
	"1001033": "查询业务失败",
	"1001034": "创建业务失败",
	"1001035": "禁止删除内置模型",
	"1001037": "创建主线失败",
	"1001038": "删除主线失败",
	"1001039": "查询主线失败",
	"1001040": "查询模型拓扑失败",
	"1001041": "创建用户分组",
	"1001042": "删除用户分组",
	"1001043": "更新用户分组",
	"1001044": "查询用户分组",
	"1001045": "更新用户分组权限",
	"1001046": "查询用户分组权限",
	"1001047": "查询用户权限",
	"1001048": "创建角色权限",

	"1101080":"模块不存，请刷新页面",
	"":""

}

```

### api_v2

``` json
{
    "1170001":"业务名称必须1-32个字符",
    "1170002":"%s",
    "1170003":"集群名称长度不能超过24个字节",
    "1170004":"每个模块ID都必须是数字",
    "1170005":"每个集群ID都必须是数字",
    "1170006":"osType必须是windows或linux",
    "1170007":"多模块转移不能包含默认模块",

    "":""
}

```

